Package io.vertx.reactivex.ext.auth.otp.hotp

## Class HotpAuth

- java.lang.Object
- - io.vertx.reactivex.ext.auth.authentication.AuthenticationProvider
  - - io.vertx.reactivex.ext.auth.otp.hotp.HotpAuth

- All Implemented Interfaces:
    `io.vertx.lang.rx.RxDelegate`

      public class HotpAuth
      extends AuthenticationProvider
      implements io.vertx.lang.rx.RxDelegate

  An extension of AuthProvider which uses the one time passwords based on counter to perform authentication.

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static io.vertx.lang.rx.TypeArg<HotpAuth>` | `__TYPE_ARG` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `HotpAuth​(HotpAuth delegate)` |
    `HotpAuth​(Object delegate)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `HotpAuth` | `authenticatorFetcher​(Function<String,​Single<Authenticator>> fetcher)` | Provide a that can fetch s from a backend given an `identifier` argument.
    `HotpAuth` | `authenticatorFetcher​(Function<String,​Future<Authenticator>> fetcher)` | Provide a that can fetch s from a backend given an `identifier` argument.
    `HotpAuth` | `authenticatorUpdater​(Function<Authenticator,​Completable> updater)` | Provide a that can update or insert a .
    `HotpAuth` | `authenticatorUpdater​(Function<Authenticator,​Future<Void>> updater)` | Provide a that can update or insert a .
    `static HotpAuth` | `create()` | Creates an instance of HotpAuth.
    `static HotpAuth` | `create​(HotpAuthOptions hotpAuthOptions)` | Creates an instance of HotpAuth.
    `Future<Authenticator>` | `createAuthenticator​(String id, OtpKey otpKey)` | Creating authenticator from user id and key.
    `boolean` | `equals​(Object o)` |
    `String` | `generateUri​(OtpKey otpKey, String label)` | Creating URI for register in key in user device.
    `String` | `generateUri​(OtpKey otpKey, String issuer, String user)` | Creating URI for register in key in user device.
    `String` | `generateUri​(OtpKey otpKey, String issuer, String user, String label)` | Creating URI for register in key in user device.
    `HotpAuth` | `getDelegate()` |
    `int` | `hashCode()` |
    `static HotpAuth` | `newInstance​(HotpAuth arg)` |
    `Single<Authenticator>` | `rxCreateAuthenticator​(String id, OtpKey otpKey)` | Creating authenticator from user id and key.
    `String` | `toString()` |

    - ### Methods inherited from class io.vertx.reactivex.ext.auth.authentication.AuthenticationProvider

      `authenticate, newInstance, rxAuthenticate`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<HotpAuth> __TYPE_ARG

  - ### Constructor Detail

    - #### HotpAuth

          public HotpAuth​(HotpAuth delegate)

    - #### HotpAuth

          public HotpAuth​(Object delegate)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `AuthenticationProvider`

    - #### equals

          public boolean equals​(Object o)

      Overrides:
        `equals` in class `AuthenticationProvider`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `AuthenticationProvider`

    - #### getDelegate

          public HotpAuth getDelegate()

      Specified by:
        `getDelegate` in interface `io.vertx.lang.rx.RxDelegate`
      Overrides:
        `getDelegate` in class `AuthenticationProvider`

    - #### authenticatorFetcher

          public HotpAuth authenticatorFetcher​(Function<String,​Future<Authenticator>> fetcher)

      Provide a that can fetch s from a backend given an `identifier` argument.

      The function signature is as follows:

      `(id) -> Future`

      - `id` the identifier to lookup.
      - async result with a authenticator.
      Parameters:
        `fetcher` - fetcher function.
      Returns:
        fluent self.

    - #### authenticatorFetcher

          public HotpAuth authenticatorFetcher​(Function<String,​Single<Authenticator>> fetcher)

      Provide a that can fetch s from a backend given an `identifier` argument.

      The function signature is as follows:

      `(id) -> Future`

      - `id` the identifier to lookup.
      - async result with a authenticator.
      Parameters:
        `fetcher` - fetcher function.
      Returns:
        fluent self.

    - #### authenticatorUpdater

          public HotpAuth authenticatorUpdater​(Function<Authenticator,​Future<Void>> updater)

      Provide a that can update or insert a . The function should store a given authenticator to a persistence storage.

      When an authenticator is already present, this method must at least update , and is not required to perform any other update.

      For new authenticators, the whole object data must be persisted.

      The function signature is as follows:

      `(Authenticator) -> Future`

      - the authenticator data to update.
      - async result of the operation.
      Parameters:
        `updater` - updater function.
      Returns:
        fluent self.

    - #### authenticatorUpdater

          public HotpAuth authenticatorUpdater​(Function<Authenticator,​Completable> updater)

      Provide a that can update or insert a . The function should store a given authenticator to a persistence storage.

      When an authenticator is already present, this method must at least update , and is not required to perform any other update.

      For new authenticators, the whole object data must be persisted.

      The function signature is as follows:

      `(Authenticator) -> Future`

      - the authenticator data to update.
      - async result of the operation.
      Parameters:
        `updater` - updater function.
      Returns:
        fluent self.

    - #### createAuthenticator

          public Future<Authenticator> createAuthenticator​(String id,
                                                           OtpKey otpKey)

      Creating authenticator from user id and key.
      Parameters:
        `id` - id user.
        `otpKey` - key of user used for auth.
      Returns:
        an object containing all the necessary information to authenticate a user.

    - #### rxCreateAuthenticator

          public Single<Authenticator> rxCreateAuthenticator​(String id,
                                                             OtpKey otpKey)

      Creating authenticator from user id and key.
      Parameters:
        `id` - id user.
        `otpKey` - key of user used for auth.
      Returns:
        an object containing all the necessary information to authenticate a user.

    - #### generateUri

          public String generateUri​(OtpKey otpKey,
                                    String issuer,
                                    String user,
                                    String label)

      Creating URI for register in key in user device.
      Parameters:
        `otpKey` - user key.
        `issuer` - issuer of key.
        `user` - display name of user account.
        `label` - the label to identify which account a key is associated with.
      Returns:
        uri containing the key.

    - #### generateUri

          public String generateUri​(OtpKey otpKey,
                                    String issuer,
                                    String user)

      Creating URI for register in key in user device.
      Parameters:
        `otpKey` - user key.
        `issuer` - issuer of key.
        `user` - display name of user account.
      Returns:
        uri containing the key.

    - #### generateUri

          public String generateUri​(OtpKey otpKey,
                                    String label)

      Creating URI for register in key in user device.
      Parameters:
        `otpKey` - user key.
        `label` - the label to identify which account a key is associated with.
      Returns:
        uri containing the key.

    - #### create

          public static HotpAuth create()

      Creates an instance of HotpAuth.
      Returns:
        the created instance of `HotpAuth`.

    - #### create

          public static HotpAuth create​(HotpAuthOptions hotpAuthOptions)

      Creates an instance of HotpAuth.
      Parameters:
        `hotpAuthOptions` - the config.
      Returns:
        the created instance of `HotpAuth`.

    - #### newInstance

          public static HotpAuth newInstance​(HotpAuth arg)